# Pef1  - Interpolation error	(defaults to prediction error)
#
#	<in.H	Pef1 [options]  >out.H
#
#	nf=10 		filter length
#	lag=1 		location in filter of output point.
#	gap1=lag,gapn=lag	gap where filter constrained 0 or 1.
#				MUST HAVE:  gap1 <= lag <= gapn
#	j2=1		Number of traces in "super trace" with same filter.
#			=1 means a separate filter for each trace.
# Weighting:
#	nstage=1	number of stages of reweighting.
#	percent=20	noise level (see below)
#	nonuniform=0	=0  w(t)=uniform
#			=1  w(t)=1/|env(t) + percent*max(env)|
# Outputs:
#	padin=padin.H	input data padded with a spike.
#	filter=filter.H	filters, n2 of them.
#
# JFC 
# keyword interpolation prediction
#% end of self documentation
# D O N' T   M E S S   W I T H   T H I S  P R O G R A M
#		(unless you want to regenerate all book figures!)
# Author - JFC
#
integer n1, n2, n3, m, n1pf
from history:	integer n1:nd, n2=1 , n3=1
from par:	integer nf=10
		n1 = nd + 3 * nf
		m = n1 * n2
allocate:	real xx(m), yy(m), ww(m), s1(m), s2(m), s3(m)
		call putch('n1','i',n1)
		call auxputch(   'n1','i',n1, 'padin')
		call auxputch(   'n2','i',n2, 'padin')
		call auxputch(   'n3','i',1 , 'padin')
		call auxputch('esize','i',4,  'padin')

subroutine doit( nf, nd, n1, n2, n3, xx, yy, ww, s1, s2, s3)
integer	nd, esize, i1, n1, i2, n2, i3, n3
real	xx(n1,n2), yy(n1,n2), ww(n1,n2), s1(1),s2(1),s3(1)
real	ff(400), df(400), s(400)
integer	nf, niter, lag, gap1, gapn, j2, nleft, i
integer nonuniform, istage, nstage
real	lambda, big, percent, sum
call putlin('Interpolation error filter')
from history:	integer esize
from par:	integer niter=nf, lag=1, gap1=lag, gapn=lag, j2=1
from par:	integer nonuniform=0, nstage=1
from par:	real lambda=0., percent=20.
				percent = percent/100.
if( lambda < 1.e-10)
				lambda = 1.e-10
call putch('im here','i',-2)#new
if( nstage > 1)
	nonuniform = 1
call putch('Since nstage>1, you want nonuniform','1',nonuniform)
call putch('im here','i',-1)#new
call hclose()					#close header, no more putch

do i3=1,n3 {

do i1=1,n1
    do i2=1,n2
	ww(i1,i2) = 1.
nleft = n2
while( nleft > 0 ) {			# pull off super traces
	j2 = min( nleft, j2)
	nleft = nleft - j2
	do i2=1,j2
		do i1=1,n1
			xx(i1,i2) = 0.
	call sreed(  'in', xx,  esize * nd * j2 )
	big = 1.e-30
	do i2=1,j2
		do i1=1,n1
			if( big < abs(xx(i1,i2)))
				big = abs(xx(i1,i2))
	do i2=1,j2
		do i1=1,n1
			xx(i1,i2) = xx(i1,i2) / big
	do i2=1,j2
			xx(nd+2*nf, i2) = 1.
	call srite( 'padin', xx, esize*n1*j2 )  ######## eeekkk
	if( nonuniform > 0 )
		do i2=1,j2
		    do i1=1,n1
			yy(i1,i2) = xx(i1,i2)
	do istage = 1, nstage {
		if( nonuniform > 0 )
			do i2=1,j2 {
				do i1=1,nd
					ww(i1,i2) = 1./( abs(yy(i1,i2))+percent)
				do i1=nd+1, nd+nf
					ww(i1,i2) = 1.e-10
			     }
		do i2=1,j2 {
			sum = 0.
			do i1=1,nd
				sum = sum + (ww(i1,i2) * xx(i1,i2)) **2
			do i1=nd+nf, n1
				ww(i1,i2) = sqrt(sum) * lambda
			}
		call pef1( nf,ff, n1*j2,
			xx,yy,ww,niter,lag,gap1,gapn)
#					df, s1, s2, s, s3)
		}
	big = 1.e-30				# normalize output traces
	do i2=1,j2
		do i1=1,nd+nf-1
			if( big < abs(yy(i1,i2)))
				big = abs(yy(i1,i2))
	do i2=1,j2
		do i1=1,nd+nf-1
			yy(i1,i2) = yy(i1,i2) / big

	big = 1.e-30				# normalize output filters
	do i2=1,j2
		do i1=nd+nf,n1
			if( big < abs(yy(i1,i2)))
				big = abs(yy(i1,i2))
	do i2=1,j2
		do i1=nd+nf,n1
			yy(i1,i2) = yy(i1,i2) / big

	call srite( 'out',   yy, esize*n1*j2 )
	do i2=1,j2 {
		call snap('filter', nf,1,ff)
		}
	}
}
return; end

