
program CarveHole

	use sep

	implicit none

	integer                        :: n1, n2, i1, i2
	integer                        :: x0, y0
	integer                        :: nell1, nell2
	integer                        :: hole

	real                           :: ellip

	real, dimension(:,:), pointer  :: trn_im, out_im, auxmask

	call sep_init()

	call from_either( "n1", n1 )
	call from_either( "n2", n2 )

	call from_par( "nell1", nell1, n1/4)
	call from_par( "nell2", nell2, n2/4)
	call from_par( "hole", hole, 1)
	call from_par( "x0", x0, n1/2)
	call from_par( "y0", y0, n2/2)
	
	allocate( out_im(n1,n2), trn_im(n1,n2), auxmask(n1,n2) )

	call sep_read( trn_im)
	
	out_im = trn_im + 0.00001

  ! Carve an Ellipse 
	if( hole == 1) then
	
		write(0,*) 'Carving ellipse'

		do i1 = 1,n1
			do i2 = 1,n2
				ellip = (1.0*(i1-x0)/nell1)**2 + (1.0*(i2-y0)/nell2)**2
				if( ellip .le. 1.0) then
					out_im( i1,i2) = 0.0
				end if
			end do
		end do

	else

		write(0,*) 'Manual mask'
		call sep_read( auxmask, file="auxmask")
!		where( auxmask == 0.0)  out_im = 0.0
		where( auxmask /= 0.0)  out_im = 0.0

	end if

	call to_history( "n1", n1)
	call to_history( "n2", n2)
	call sep_write( out_im)

	call exit(0)

end program CarveHole
