program HoleyTo1D

	use sep

	implicit none

	integer                         :: n1, n2, ndat, i, j
	real, dimension(:), pointer     :: data, mask, output

	call sep_init()
	call from_history( n1, n2)

	allocate( mask(n1*n2), data(n1*n2) )

	call sep_read(data)
	mask = 1.0
	if( exist_file("mask") )  call sep_read(mask, "mask")
	where( mask/=1.0) mask=0.0
	ndat = nint( sum(mask) )

	allocate( output(ndat) )

	call to_history( "n1", ndat)
	call to_history( "n2", 1)
	call to_history( "esize", 4)
	call to_history( "var", sum(data*data)/(1.0*ndat) )
	call to_history( "mean",  sum(data)/ndat )
	call to_history( "m1",  n1 )
	call to_history( "m2",  n2 )

	output=0;  j = 1
	do i=1,n1*n2
		if( mask(i) == 1.0) then
			output(j)=data(i)
			j=j+1
		end if
	end do

	call to_history( "min",  minval(output) )
	call to_history( "max",  maxval(output) )
	call sep_close()

	call sep_write( output)

	deallocate( data, mask, output)

	call exit(0)

end program HoleyTo1D
