program TransformHistogram

	use sep
	use random_mod

	implicit none

	integer                         :: n1, n2, nbin, iseed, i1, i2
	integer                         :: randx
	real                            :: randy, mindat, maxdat, dbin
	real, dimension(:), pointer     :: pdf
	real, dimension(:,:), pointer   :: rand_data

	call sep_init()
	call from_history( nbin)
	call from_param( "seed", iseed, 1737)
	call from_either( "m1", n1 )
	call from_either( "m2", n2 )
	call from_either( "min", mindat )
	call from_either( "max", maxdat )

	allocate( pdf(nbin) )

	call sep_read( pdf)

write(0,*) 'min/max/size(pdf)', minval(pdf),maxval(pdf),size(pdf)
	pdf = ( pdf - minval(pdf) )/( maxval(pdf) - minval(pdf) )

	allocate( rand_data(n1,n2) )
	call random_init( iseed) 

	dbin = (maxdat-mindat)/nbin

	do i1=1,n1
		do i2=1,n2
			randx = 1;  randy = 1e10
			do while( randy > pdf(randx) )
				call rand_int( randx, 1, nbin);
				call rand_real( randy)
			end do
			rand_data(i1,i2) = randx*dbin + mindat
		end do
	end do

write(0,*) 'INPUT TO T.H.: min/max', mindat,maxdat
write(0,*) 'OUTPUT OF T.H.: min/max', minval(rand_data),maxval(rand_data)

	call to_history( "n1", n1);  call to_history( "n2", n2)
	call to_history( "esize", 4)
	call sep_write( rand_data )
	call sep_close()
	deallocate( rand_data, pdf)

	call exit(0)

end program TransformHistogram
