# All-pass filter with filters of a particular type
#
#	<in.H	Allpass rho=.85 ncon=2  >out.H
#
#	rho:	rho has the obvious meaning as in all my books
#	ncon:	Polynomial is applied 2**ncon times.
#			goes unstable if ncon too big.
#
# keyword allpass all-pass filter
#% end of self documentation
# Author - JFC
#
integer n1
from history:	integer n1
allocate:	real xx(n1), yy(n1)

subroutine doit( n1, xx, yy)
integer n1, i1, esize, na, nb, nc, icon, ncon, i2, n2, i3, n3
real xx(n1), yy(n1)
real aa(500), bb(500), rho, space(4000), temp(1000)
call putlin('All pass filter the 1-axis.')
from history:	integer esize, n1, n2=1, n3=1
from par:	integer ncon=2
from par:	real	rho=.85
call hclose()					#close header, no more putch

na = 2
aa(1) = 1.
aa(2) = - rho
do icon=1, ncon {		# warning, if you go higher than about 4,
			#	it'll go unstable.
	call convolve( na, aa, na, aa, temp )
	na = na + na - 1
	do i1 = 1, na
		aa(i1) = temp(i1)
	}
nb = na
do i1=1,na
	bb(nb-i1+1) = aa(i1)

do i3=1,n3 {
do i2=1,n2 {
	call sreed(  'in', xx, esize*n1 )
	call convolve( nb, bb, n1, xx, yy)
	call polydiv( na, aa, n1, yy, n1, xx)
	call srite( 'out', xx, esize*n1 )
	}}

return; end
