program Lev_int
  ! Levint -- Leveler inverse interpolate in 1-D
  !
  ! <in.H Levint o1= d1=  >out.H
  !  input- 
  ! in.H in(2,n2) = ordinate, coordinate pairs.
  ! n1 output model size.
  ! niter=n1 iteration count
  !  output-
  ! out.H inverse linear interpolated model mesh mm(m1)
  use sep
  use levint

  implicit none
  integer                                    :: n2, nd, m1, na, nr, niter
  real, dimension (:),   pointer             :: mm, aa, dd, coord
  real, dimension (:),   allocatable, target :: rr
  real, dimension (:,:), allocatable, target :: pair, mmov
  real                                       :: o1, d1, eps

  call sep_init ()

  ! create model
  call from_par ("n1", m1)
  call to_history ("n2", 1)
  call from_par ("niter", niter, 1 + m1*3/2)
  call from_history ("o1", o1)
  call from_history ("d1", d1)
  call from_par ("eps",eps,0.2)

  ! create filter
  call from_par ("na",na,3)
  nr = m1 + na
  allocate (rr (nr)) ; rr = 0.
  mm => rr (1 : m1  ) 
  aa => rr (1 + m1 :) 

  ! read data
  call from_history (nd, n2)
  if (n2 /= 2) call erexit ('bad n2')
  allocate (pair (nd,2))
  call sep_read (pair)
  coord => pair (1:nd,1)
  dd    => pair (1:nd,2)

  niter = niter*2

  ! create movies
  allocate (mmov (m1, niter))
  call to_history ("n1",m1   ,"mm")
  call to_history ("n2",niter,"mm")
  call to_history ("n3",1    ,"mm")
  call sep_close()   

  call levint1 (niter, coord, dd, o1, d1, aa, mm, mmov, rr, eps)

  call sep_write (mm)
  call sep_write (mmov, "mm")

  deallocate (rr, pair, mmov)
  call exit (0)
end program Lev_int





