module levint_mod
  use tcai1
  use peftc
  use int1
  use interp
  use cgstep_mod
  use solver_mod

  implicit none

contains

  subroutine levint (niter, coord, dd, o1, d1, aa, mm, mmov, rr)
    integer,               intent (in)    :: niter
    real,                  intent (in)    :: o1, d1
    real, dimension (:),   pointer        :: aa, mm, coord
    real, dimension (:),   intent (in)    :: dd
    real, dimension (:),   intent (inout) :: rr
    real, dimension (:,:), intent (out)   :: mmov

    integer                               :: nr, nm
    logical, dimension (size (rr))        :: ma

    nm = size (mm)
    nr = size (rr)

    call int1_init (coord, o1, d1, nm, lin_int, 2)
    call peftc_init (aa, mm) ; aa (1 : 3) = (/ 1., -2., 1. /)

    call cgstep_init () ; ma (:nm) = .false.  ; ma (nm+1:) = .true.
    call solver (int1_op, cgstep, reg = peftc_op, nreg = nr, nlreg = tcai1_op, &
    niter = niter, x0 = rr, x = rr, dat = dd, xmov = mmov, mask = ma)
    ma (nm+2:) = .false. 
    call cgstep_close () ; call cgstep_init ()
    call solver (int1_op, cgstep, reg = peftc_op, nreg = nr, nlreg = tcai1_op, &
    niter = niter, x0 = rr, x = rr, dat = dd, xmov = mmov, mask = ma)
    call cgstep_close ()

    call int1_close ()
  end subroutine levint

end module levint_mod

