! Make a segment of a damped sine wave, subsampled.
!
use sep

implicit none

integer 				:: n1, n2, n3, esize, i1
real, dimension (:), allocatable	:: xx
real 					:: arg, time, period, where
real, parameter				:: pi = 3.14159265

call sep_init ()
call from_par ("n1", n1, 100)
call from_par ("n2", n2, 1)
call from_par ("n3", n3, 1)
call from_par ("esize", esize, 4)
call from_par ("period", period, 15.)
call from_par ("where", where, .7)
call sep_close ()

allocate ( xx (n1)) ; xx = 0.
do i1=n1/4, n1/2 
	time = (i1-n1/4)
	arg = 2.* pi * time /period
	xx(i1) = sin ( arg) * exp( - 4.* time/n1)
end do
i1 = where * n1
xx( i1 ) = 1.

call sep_write (xx)
deallocate (xx)

call exit (0)
end
